 jQuery.fn.alternateRowColors = function() {
   $('tbody tr:odd', this)
     .removeClass('even').addClass('odd');
   $('tbody tr:even', this)
     .removeClass('odd').addClass('even');
   return this;
 };

 $(document).ready(function() {
   $('table.sortable').each(function() {
     var $table = $(this);
     $table.alternateRowColors();
     $('th', $table).each(function(column) {
       var $header = $(this);
       var findSortKey;
       if ($header.is('.sort-alpha')) {
         findSortKey = function($cell) {
           return $cell.find('.sort-key').text().toUpperCase()
             + ' ' + $cell.text().toUpperCase();
         };
       }
       else if ($header.is('.sort-numeric')) {
         findSortKey = function($cell) {
//           var key = $cell.text().replace(/^[^\d.]*/, '');
           var key = $cell.text().replace(' ', '');
           key = parseFloat(key);
           return isNaN(key) ? 0 : key;
         };
       }
       else if ($header.is('.sort-date')) {
         findSortKey = function($cell) {
           return Date.parse('1 Jan' + $cell.text());
         };
       }
           
       if (findSortKey) {
         $header.addClass('clickable').hover(function() {
           $header.addClass('hover');
         }, function() {
           $header.removeClass('hover');
         }).click(function() {
           var rows = $table.find('tbody > tr').get();
           $.each(rows, function(index, row) {
             var $cell = $(row).children('td').eq(column);
             row.sortKey = findSortKey($cell);
           });
           rows.sort(function(a, b) {
             if (a.sortKey < b.sortKey) return -1;
             if (a.sortKey > b.sortKey) return 1;
             return 0;
           });
           $.each(rows, function(index, row) {
             $table.children('tbody').append(row);
             row.sortKey = null;
           });
           $table.alternateRowColors();
         });
       }
     });
   });
 });
